#!/usr/local/bin/python 

#
# calculate the bayesian probability of P(S|TLS)
# 5th: output only the biggest score for comparison with the annotation.
# 7th: considre about protein length.

from Numeric import *
from string import *
from gist import *
import KPDF
#from MLab import *

genome = ""
fna = open("../DB_etc/NC_002516.fna").readlines()
fna = fna[1:]
for i in range(len(fna)):
	fna[i] = fna[i].replace("\n","")
	genome = genome + fna[i]

all_len = len(genome)	#the length of all NT sequeence for Cenibacterium
#print "readfile: /Users/yukomakita/Desktop/DB/Cenibacterium/all_seq.txt", len(genome)

#####################################################################################
def findstart(allseq,ter_pos):
	around_start_seq = []
	TLS_pos = []
	for i in range(len(allseq))[2:]:
		aaseq = allseq[ter_pos-i*3:ter_pos-i*3+3]
#		print "aaseq\t\t",aaseq,i
		if aaseq in ["ATG","GTG","TTG"]:
			if i > 20:
#				print "hog",allseq[ter_pos-i*3-50:ter_pos-i*3+10]
				around_start_seq.append(allseq[ter_pos-i*3-50:ter_pos-i*3+20])
				TLS_pos.append(ter_pos-i*3+1)
				
		elif aaseq in ["TAA","TAG","TGA"]:
			break
	return around_start_seq,TLS_pos

######################################################################################
def compl(seq):
	complseq = ""
	for c in range(len(seq)):
		complseq = complseq + seq[-c-1]
	complseq = complseq.replace("A","t")
	complseq = complseq.replace("T","a")
	complseq = complseq.replace("G","c")
	complseq = complseq.replace("C","g")
	complseq = swapcase(complseq)
	
	return complseq
########################################################################################

genome_compl = compl(genome)
bh_data = open("../DB_etc/dataset_pae1").readlines()
for k in range(len(bh_data)):
	around_start_seq = []
	TLS_pos = []
	bh_data[k] = bh_data[k].replace("\n","")
	bh_data[k] = bh_data[k].split()

	if bh_data[k][11] == "-":
		TLS_bh_data = int(bh_data[k][10])
		TLS_end_pos = int(bh_data[k][9])
		around_start_seq,TLS_pos = findstart(genome_compl,len(genome_compl)-TLS_end_pos+1)
		for kk in range(len(TLS_pos)):
			TLS_pos[kk] = len(genome_compl)-TLS_pos[kk]+1
		
	else:
		TLS_bh_data = int(bh_data[k][9])
		TLS_end_pos = int(bh_data[k][10])
		around_start_seq,TLS_pos = findstart(genome,TLS_end_pos)
	
	if around_start_seq != []:
		longest = (abs(TLS_pos[-1]-TLS_end_pos)+1)/3.
		pro_len = (abs(TLS_bh_data-TLS_end_pos)+1)/3.
		pro_ratio = pro_len/longest
		print "%s\t%.3f" %(bh_data[k][1],pro_ratio)
