#!/usr/local/bin/perl -w

$infile = "res_meme";


$seqfile = "../mk_upseq/pae_up50_dw30";
open(SEQ, $seqfile) || die "Can't open $seqfile :$!\n";

while(<SEQ>){
	print $_;
	s/>//;
	@gene = split();
	$_ = <SEQ>;
	chomp;
	$seq = $_;
	$fg = 0;
	
	open(IN, $infile) || die "Can't open $infile :$!\n";
	while(<IN>){
		next unless(/^$gene[0]/);
		chomp;
		@data = split(/\t/);
		$sdseq = $data[4];
		
		$input = "\-" x $data[1];
		$seq =~ s/(\w{30})$/$input$1/;
		$input = "\-" x (50-$data[1]);
		$seq =~ s/$seq/$input$seq/;
		$seq =~ s/$sdseq/\-$sdseq\-/;
		print "$seq\n";
		$fg = 1;
		last;
	}
	print "$seq\n" if($fg == 0);
}

